Unit Pix2Main;

{	Pix2
   Version 1.4.1
   Release date: 24/06/1997 (june)

   Changes from 1.4.0 to 1.4.1:
    - I figured out that the 386 instructions in PixFillPage doesn't work,
      so I replaced it as it was before

	Changes from 1.3.1 to 1.4.0:
	 - PixDump, PixCopyPage and PixFillPage are speeded up a bit by using 386
		instructions instead of regular instructions.
	 - Added XMS support for images.

	Changes from 1.3.0 to 1.3.1:
    - I've added the PixGetClip function in Pix2Main.
    - The keyboard handler automatically remove itseld if you forget
      to remove it
    - The Pix2Tmr module has been added.
    - The directory structure is complete, so it include all files
      required for making a game.

	Changes from 1.2.0 to 1.3.0:
	 - I've split up Pix2 into several modules as I did for Pix1.  This way,
		each module is specific, and you only include the code you need in
		your game.
	 - I've added the keyboard handling and joystick handling into Pix2.

	Changes from 1.0.0 to 1.0.5:
	 - Added the PIXDEBUG IFDEF checks that generate extra code for debug
		reasons if defined
	 - Added code into functions that does file I/O to report any I/O errors
	 - Major parts of variables are now private to Pix2


	*** Note that other modules WON'T include any documentation, all the
		 Pix2 related informations will be in this file, or in the included
       Pix2Ref.Txt file.
}

{
	DISCLAIMER:  PIX2 IS DISTRIBUTER ON AN "AS-IS" BASIS, MEANING THAT WE
	(THE AUTHORS) AREN'T RESPONSIBLE FOR ANY RESULTS DUE TO THE USE OR
	MIS-USE OF THIS CODE.
	PIX2 IS DISTRIBUTED FREELY WITH SOURCE CODE AS FREEWARE.  YOU MAY USE
	IT FOR EITHER PERSONNAL OR COMMERCIAL USES WITHOUT PAYING ANY FEES NOR
	ROYALTIES.  YOU CAN MODIFY THE CODE FOR PERSONNAL NEEDS.
	YOU MAY ALSO COPY THE PIX2 PACKAGE TO EVERYONE YOU WANT, DISTRIBUTE IT
	ON SHAREWARE/FREEWARE CD-ROMS OR DISKS, AS LONG AS NO MONEY IS BEING
	IMPLIED FOR PIX2 ITSELF.
	IF YOU MODIFY THE SOURCE CODE, YOU MAY NOT RE-DISTRIBUTE THE MODIFIED
	PART IN ANY WAY, WITHOUT THE WRITTEN PERMISSION OF THE AUTHORS.  MAJOR
	OR MINOR IMPROVEMENT TO THE CODE SHOULD BE SUBMITTED TO JONATHAN
	NICOLAS.
	blah, blah, blah...

	Stay tuned!
	Maybe this isn't the latest version of Pix2 you have!!!
	Be sure by checking the official Pix homepage:
	http://www.geocities.com/SiliconValley/Vista/4490

	To contact me, Jonathan Nicolas, send an e-mail at joun@quebectel.com

	Don't forget to report any bugs, or submit code and/or ideas to me!!!

	Have fun!!!
}

(*
	If you want extra code generated for debug reasons, include the line
	{$DEFINE PIXDEBUG} just between the {$R-} and Interface directives.
	Include this line in every module in which you'd like this extra code
	to be generated.  Note that not all modules uses that kind of debuging,
	but the line is normally added to all modules, in case...
	Extra code will range-check for virtual pages, check valid pointers,
	and other verifications so ensure that programming is done right.
	Once final release is expected, just remove the line and re-compile
	all the Pix2 modules in order to remove this code from the executable.
*)

(*
	To recompile the kernel, make sure you have all the object (*.OBJ) files
	which are linked with the code.
*)

{$I-}
{$G+}
{$R-}
{$Q-}

(* The {$DEFINE PIXDEBUG} should be here *)
{$DEFINE PIXDEBUG}

Interface

Type
	PBuf=^TBuf;
	TBuf=Array[0..63999] Of Byte;
	RGB=Record
		R,G,B:Byte;
	End;
	PixPaletteP=^PixPalette;
	PixPalette=Array[0..255] Of RGB;
	PixPalType=(PIXPALVAR,CURRENT,SPECIFIEDVAR,NOWHERE);

	PixSprite=Object
		X,Y:Integer;
		Img:Array[1..20,1..20] Of Pointer;
		NbFrm,CurFrm:Array[1..20] Of Byte;
		CurSet:Byte;
		Way:Byte;
		Constructor Init;
		Procedure AddFrame(NSet:Byte;NImg:Pointer);
		Procedure NewSet(NSet:Byte);
		Procedure Draw;
		Function Step:Boolean;
		Function StepRev:Boolean;
		Function PingPong:Boolean;
		Destructor Done;
	End;

{ Basic Video Management & Drawing Functions }
Function PixOpen(NbPages:Byte):Boolean;
Procedure PixClose;
Procedure PixScreen(InfoStr:String);
Procedure PixSelPage(NewPage:Byte);
Function PixGetPage:Byte;
Procedure PixWaitVSync;
Procedure PixSetClip(X1,Y1,X2,Y2:Integer);
Procedure PixGetClip(Var X1,Y1,X2,Y2:Integer);
Procedure PixFillPage(Col:Byte);
Procedure PixPutPixel(X,Y:Integer;Col:Byte);
Procedure PixHLine(X1,X2,Y:Integer;Col:Byte);
Procedure PixVLine(Y1,Y2,X:Integer;Col:Byte);
Procedure PixBox(X1,Y1,X2,Y2:Integer;Col:Byte);
Procedure PixFilledBox(X1,Y1,X2,Y2:Integer;Col,ColIn:Byte);
Procedure PixLine(X1,Y1,X2,Y2:Integer;Col:Byte);
Function PixGetPixel(X,Y:Integer):Byte;
Procedure PixDump;
Procedure PixCopyPage(Source,Dest:Byte);

{ Palette Management Functions }
Procedure PixSetRGB(Col,R,G,B:Byte);
Procedure PixGetRGB(Col:Byte;Var R,G,B:Byte);
Procedure PixSetPalette(Pal:PixPaletteP);
Procedure PixGetPalette(Pal:PixPaletteP);
Procedure PixBlackOutPalette(Pal:PixPaletteP);
Procedure PixResetPalette(Pal:PixPaletteP);
Procedure PixFadeOutPalette(Pal:PixPaletteP);
Procedure PixFadeInPalette(Pal:PixPaletteP;Goal:PixPaletteP);
Procedure PixRotatePalette(Pal:PixPaletteP;From,Too:Byte);
Procedure PixRotatePaletteRev(Pal:PixPaletteP;From,Too:Byte);
Function PixSavePalette(FName:String;Pal:PixPaletteP):Boolean;
Function PixLoadPalette(FName:String;Pal:PixPaletteP):Boolean;

{ Bitmap manipulation functions }
Function PixGetImage(Var P:Pointer;X1,Y1,X2,Y2:Integer;Alloc:Boolean):Boolean;
Procedure PixPutImage(P:Pointer;X1,Y1:Integer;Trans:Boolean);
Procedure PixSaveImage(P:Pointer;FName:String;WPal:PixPalType;Pal:PixPaletteP);
Procedure PixLoadImage(Var P:Pointer;FName:String;WPal:PixPalType;Pal:PixPaletteP);
Procedure PixLoadPri(Var P:Pointer;FName:String);
Procedure PixDeAllocImage(Var P:Pointer);

{ Utility functions }
Function PixIntToStr(Num:LongInt):String;
Function PixStrToInt(S:String):LongInt;

{ Global Variables }
Var
	PixPal:PixPalette;
	Pages:Array[0..8] Of PBuf;
	PgLong:LongInt;

Implementation

Uses
	Crt;

{ Private Variables }
Var
	RealPal:PixPalette;
	NPg:Byte;
	ClipX1,ClipY1,ClipX2,ClipY2:Integer;
	CurPg:Byte;
	PgSeg:Word;

Procedure DefPal; External;
{$L DEFPAL.OBJ}

Procedure PixScreen(InfoStr:String);
Var
	C:Byte;
Begin
	ClrScr;
	TextColor(15);
	TextBackGround(1);
	For C:=1 To 80 Do
		Write(' ');
	GotoXY(1,1);
	Write(' PIX2 -> ',InfoStr);
	TextColor(7);
	TextBackground(0);
	GotoXY(1,3);
End;

Function PixOpen(NbPages:Byte):Boolean;
Var
	C,D:Byte;
Begin
	PixOpen:=False;
	{$IFDEF PIXDEBUG}
		If (NbPages<0) Or (NbPages>8) Then
		Begin
			PixScreen('Programming error occured');
			WriteLn('Illefal number of virtual pages in function PixOpen.');
			Halt(0);
		End;
	{$ENDIF}
	If MemAvail<(NbPages*64000) Then
		Exit;
	For C:=1 To NbPages Do
	Begin
		If MaxAvail<64000 Then
		Begin
			For D:=1 To C-1 Do
				Dispose(Pages[D]);
			Exit;
		End;
		New(Pages[C]);
	End;
	Asm
		mov AH,0
		mov AL,13h
		int 10h
	End;
	Pages[0]:=Ptr($A000,0);
	NPg:=NbPages;
	ClipX1:=0; ClipY1:=0; ClipX2:=319; ClipY2:=199;
	PixSelPage(0);
	Move(Pointer(@DefPal)^,RealPal,768);
	PixSetPalette(@DefPal);
	PixGetPalette(@PixPal);
	PixOpen:=True;
End;

Procedure PixClose;
Var
	C:Byte;
Begin
	Asm
		mov AH,0
		mov AL,03h
		int 10h
	End;
	For C:=1 To NPg Do
		Dispose(Pages[C]);
	NPg:=0;
End;

Procedure PixSelPage(NewPage:Byte);
Begin
	{$IFDEF PIXDEBUG}
		If NewPage>NPg Then
		Begin
			PixClose;
			PixScreen('Progamming error occured');
			WriteLn(#7,'You tried to acces un-allocated virtual page in procedure PixSelPage');
			Halt(0);
		End;
	{$ENDIF}
	CurPg:=NewPage;
	PgSeg:=Seg(Pages[CurPg]^);
	PgLong:=LongInt(PgSeg) Shl 16;
End;

Function PixGetPage:Byte;
Begin
	PixGetPage:=CurPg;
End;

Procedure PixWaitVSync;
Begin
	Asm
		mov DX,03DAh
	  @wvlp1:
		in AL,DX
		and AL,08h
		jnz @wvlp1
	  @wvlp2:
		in AL,DX
		and AL,08h
		jz @wvlp2
	End;
End;

Procedure PixSetClip(X1,Y1,X2,Y2:Integer);
Begin
	{$IFDEF PIXDEBUG}
		If (X1>=X2) Or (Y1>=Y2) Or (X1<0) Or (X2>319) Or (Y1<0) Or (Y1>199) Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Illegal clipping rectangle defined in PixSetClip.');
			Halt(0);
		End;
	{$ENDIF}
	ClipX1:=X1; ClipY1:=Y1; ClipX2:=X2; ClipY2:=Y2;
End;

Procedure PixGetClip(Var X1,Y1,X2,Y2:Integer);
Begin
	X1:=ClipX1;
	Y1:=ClipY1;
	X2:=ClipX2;
	Y2:=ClipY2;
End;

Procedure PixDump;
Begin
	Asm
		push DS
		lds SI,PgLong
		mov AX,$A000
		mov ES,AX
		xor DI,DI
		mov CX,16000
		db $66
		rep movsw
		pop DS
	End;
End;

Procedure PixCopyPage(Source,Dest:Byte);
Var
	Ls,Ld:LongInt;
Begin
	{$IFDEF PIXDEBUG}
		If (Source>NPg) Or (Dest>NPg) Then
		Begin
			PixClose;
			PixScreen('Progamming error occured');
			WriteLn(#7,'You tried to acces un-allocated virtual page in procedure PixPageCopy');
			Halt(0);
		End;
	{$ENDIF}
	Ls:=LongInt(Seg(Pages[Source]^)) Shl 16;
	Ld:=LongInt(Seg(Pages[Dest]^)) Shl 16;
	Asm
		push DS
		lds SI,Ls
		les DI,Ld
		mov CX,16000
		db $66
		rep movsw
		pop DS
	End;
End;

Procedure PixFillPage(Col:Byte);
Begin
	Asm
		les DI,PgLong
		mov AH,Col
		mov AL,AH
      mov CX,32000
		rep stosw
	End;
End;

Procedure PixPutPixel(X,Y:Integer;Col:Byte);
Begin
	Asm
		mov AX,X
		cmp AX,[ClipX1]
		jl @putpixelskip
		cmp AX,[ClipX2]
		jg @putpixelskip
		mov AX,Y
		cmp AX,[ClipY1]
		jl @putpixelskip
		cmp AX,[ClipY2]
		jg @putpixelskip
		les DI,[PgLong]
		mov DI,[X]
		mov AX,[Y]
		mov BX,AX
		shl AX,8
		shl BX,6
		add DI,AX
		add DI,BX
		mov AL,[Col]
		stosb
	  @putpixelskip:
	End;
End;

Procedure PixHLine(X1,X2,Y:Integer;Col:Byte);
Begin
	Asm
		mov AX,Y
		cmp AX,[ClipY1]
		jl @hlineskip
		cmp AX,[ClipY2]
		jg @hlineskip
		mov AX,X1
		cmp AX,X2
		jl @hlinecont
		push X2
		push X1
		pop X2
		pop X1
	  @hlinecont:
		mov AX,X1
		cmp AX,[ClipX1]
		jge @hlinec1
		push [ClipX1]
		pop X1
	  @hlinec1:
		cmp AX,[ClipX2]
		jg @hlineskip
		mov AX,X2
		cmp AX,[ClipX1]
		jl @hlineskip
		cmp AX,[ClipX2]
		jle @hlinec2
		push [ClipX2]
		pop X2
	  @hlinec2:
		mov CX,X2
		sub CX,X1
		inc CX
		les DI,[PgLong]
		mov AX,Y
		mov BX,AX
		shl AX,8
		shl BX,6
		mov DI,AX
		add DI,BX
		add DI,X1
		mov AL,[Col]
		rep stosb
	  @hlineskip:
	End;
End;

Procedure PixVLine(Y1,Y2,X:Integer;Col:Byte);
Begin
	Asm
		mov AX,X
		cmp AX,[ClipX1]
		jl @vlineskip
		cmp AX,[ClipX2]
		jg @vlineskip
		mov AX,Y1
		cmp AX,Y2
		jl @vlinecont
		push Y2
		push Y1
		pop Y2
		pop Y1
	  @vlinecont:
		mov AX,Y1
		cmp AX,[ClipY1]
		jge @vlinec1
		push [ClipY1]
		pop Y1
	  @vlinec1:
		cmp AX,[ClipY2]
		jg @vlineskip
		mov AX,Y2
		cmp AX,[ClipY1]
		jl @vlineskip
		cmp AX,[ClipY2]
		jle @vlinec2
		push [ClipY2]
		pop Y2
	  @vlinec2:
		mov CX,Y2
		sub CX,Y1
		inc CX
		les DI,[PgLong]
		mov AX,Y1
		mov BX,AX
		shl AX,8
		shl BX,6
		mov DI,AX
		add DI,BX
		add DI,X
		mov AL,[Col]
	  @vlineloop:
		stosb
		add DI,319
		loop @vlineloop
	  @vlineskip:
	End;
End;

Procedure PixBox(X1,Y1,X2,Y2:Integer;Col:Byte);
Begin
	PixHLine(X1,X2,Y1,Col);
	PixHLine(X1,X2,Y2,Col);
	PixVLine(Y1,Y2,X1,Col);
	PixVLine(Y1,Y2,X2,Col);
End;

Procedure PixFilledBox(X1,Y1,X2,Y2:Integer;Col,ColIn:Byte);
Var
	C:Integer;
Begin
	For C:=Y1 To Y2 Do
		PixHLine(X1,X2,C,ColIn);
	PixBox(X1,Y1,X2,Y2,Col);
End;

Procedure PixLine(X1,Y1,X2,Y2:Integer;Col:Byte);
Var
	T:Integer;
	Slop,RS,Dx,Dy:Integer;
	RY1,RY2:Integer;
	X,Y:Integer;
Begin
	If X1=X2 Then
	Begin
		PixVLine(Y1,Y2,X1,Col);
		Exit;
	End;
	If Y1=Y2 Then
	Begin
		PixHLine(X1,X2,Y1,Col);
		Exit;
	End;
	If X2<X1 Then
	Begin
		T:=X2;
		X2:=X1;
		X1:=T;
		T:=Y2;
		Y2:=Y1;
		Y1:=T;
	End;
	Dy:=Y2-Y1;
	Dx:=X2-X1;
	If Abs(Dy)<=Abs(Dx) Then
	Begin
		Slop:=Trunc((Dy*100)div Dx);
		RS:=Abs(Slop);
		X:=X1;
		Y:=Y1;
		Asm
			les DI,[PgLong]
			mov DI,[Y1]
			mov BX,DI
			shl DI,8
			shl BX,6
			add DI,BX
			add DI,[X1]
			mov AL,[Col]
			mov CX,X2
			sub CX,X1
			inc CX
			xor DX,DX
		  @LN1:
			mov SI,X
			cmp SI,[ClipX1]
			jl @lineclip
			cmp SI,[ClipX2]
			jg @lineclip
			mov SI,Y
			cmp SI,[ClipY1]
			jl @lineclip
			cmp SI,[ClipY2]
         jg @lineclip
	      mov ES:[DI],AL
        @lineclip:
         inc X
	      add DX,[RS]
	      cmp DX,99
	      jg @LN2
	      inc DI
	      loop @LN1
	      jmp @LN3
	     @LN2:
	      sub DX,100
	      cmp slop,0
			jg @LN4
	      sub DI,320
         dec Y
	      jmp @LN5
	     @LN4:
	      add DI,320
			inc Y
	     @LN5:
	      inc DI
	      loop @LN1
	     @LN3:
		End;
	End
   Else
   Begin
	   Slop:=Trunc((Dx*100)div Dy);
	   RS:=Abs(Slop);
      If Y1>Y2 Then
      Begin
      	RY1:=Y2;
			RY2:=Y1;
      End
   	Else
      Begin
      	RY1:=Y1;
         RY2:=Y2;
		End;
      X:=X1;
      Y:=Y1;
		Asm
         les DI,[PgLong]
	      mov DI,[Y1]
	      mov BX,DI
	      shl DI,8
	      shl BX,6
	      add DI,BX
	      add DI,[X1]
	      mov AL,[Col]
	     	mov CX,RY2
	      sub CX,RY1
			inc CX
	      xor DX,DX
	     @LN1B:
         mov SI,X
         cmp SI,[ClipX1]
         jl @lineclip2
			cmp SI,[ClipX2]
         jg @lineclip2
         mov SI,Y
         cmp SI,[ClipY1]
         jl @lineclip2
         cmp SI,[ClipY2]
         jg @lineclip2
	      mov ES:[DI],AL
        @lineclip2:
         cmp slop,0
         jg @LN4B
         sub DI,320
         dec Y
         jmp @LN5B
		  @LN4B:
        	add DI,320
         inc Y
        @LN5B:
	      add DX,[RS]
        	cmp DX,99
			jg @LN2B
	      loop @LN1B
	      jmp @LN3B
        @LN2B:
        	sub DX,100
         inc DI
         inc X
         loop @LN1B
	     @LN3B:
		End;
   End;
End;

Function PixGetPixel(X,Y:Integer):Byte;
Begin
   If(X<ClipX1) Or (X>ClipX2) Or (Y<ClipY1) Or (Y>ClipY2) Then
   Begin
   	PixGetPixel:=0;
      Exit;
   End;
	PixGetPixel:=Pages[CurPg]^[(Y shl 8)+(Y shl 6)+X];
End;

{*************************************************************************}
Procedure PixSetRGB(Col,R,G,B:Byte);
Begin
	Asm
   	mov DX,03C8h
		mov AL,Col
      out DX,AL
      inc DX
      mov AL,R
      out DX,AL
      mov AL,G
		out DX,AL
      mov AL,B
      out DX,AL
   End;
End;

Procedure PixGetRGB(Col:Byte;Var R,G,B:Byte);
Var
	Lr,Lg,Lb:Byte;
Begin
	Asm
   	mov DX,03C7h
      mov AL,Col
      out DX,AL
      mov DX,03C9h
      in AL,DX
      mov Lr,AL
      in AL,DX
      mov Lg,AL
      in AL,DX
		mov Lb,AL
   End;
   R:=Lr;
   G:=Lg;
   B:=Lb;
End;

Procedure PixSetPalette(Pal:PixPaletteP);
Var
   S,O:Word;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixSetPalette.');
			Halt(0);
		End;
	{$ENDIF}
	S:=Seg(Pal^);
	O:=Ofs(Pal^);
	PixWaitVSync;
	Asm
		push DS
		mov DS,S
		mov SI,O
		xor AL,AL
		mov CX,768
		mov DX,03C8h
		out DX,AL
		inc DX
		rep outsb
		pop DS
	End;
End;

Procedure PixGetPalette(Pal:PixPaletteP);
Var
	S,O:Word;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixGetPalette.');
			Halt(0);
		End;
	{$ENDIF}
	S:=Seg(Pal^);
	O:=Ofs(Pal^);
	PixWaitVSync;
	Asm
		mov ES,S
		mov DI,O
		xor AL,AL
		mov CX,768
		mov DX,03C7h
		out DX,AL
		mov DX,03C9h
		rep insb
	End;
End;

Procedure PixBlackOutPalette(Pal:PixPaletteP);
Var
	S,O:Word;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixBlackOutPalette.');
			Halt(0);
		End;
	{$ENDIF}
	S:=Seg(Pal^);
	O:=Ofs(Pal^);
	Asm
		mov ES,S
		mov DI,O
		xor AL,AL
		mov CX,384
		rep stosw
	End;
End;

Procedure PixResetPalette(Pal:PixPaletteP);
Var
	S,O,S2,O2:Word;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixResetPalette.');
			Halt(0);
		End;
	{$ENDIF}
	S:=Seg(Pal^);
	O:=Ofs(Pal^);
	S2:=Seg(RealPal);
	O2:=Ofs(RealPal);
	Asm
		push DS
		mov DS,S2
		mov SI,O2
		mov ES,S
		mov DI,O
		xor AL,AL
		mov CX,384
		rep movsw
		pop DS
	End;
End;

Procedure PixFadeOutPalette(Pal:PixPaletteP);
Var
	S,O:Word;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixFadeOutPalette.');
			Halt(0);
		End;
	{$ENDIF}
	S:=Seg(Pal^);
	O:=Ofs(Pal^);
	Asm
		push DS
		mov ES,S
		mov DI,O
		mov DS,S
		mov SI,O
		mov CX,768
	  @Fadeoutc1:
		lodsb
		cmp AL,00h
		je @foskp1
		dec AL
		stosb
		jmp @foskp2
	  @foskp1:
		inc DI
	  @foskp2:
		loop @Fadeoutc1
	End;
End;

Procedure PixFadeInPalette(Pal:PixPaletteP;Goal:PixPaletteP);
Var
	S,O,S2,O2:Word;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixFadeInPalette.');
			Halt(0);
		End;
	{$ENDIF}
	S:=Seg(Pal^);
	O:=Ofs(Pal^);
	S2:=Seg(Goal^);
	O2:=Ofs(Goal^);
	Asm
		push DS
		mov DS,S
		mov SI,O
		mov ES,S2
		mov DI,O2
		mov CX,768
	  @Fadeinc1:
		mov AL,DS:[SI]
      cmp AL,ES:[DI]
      jge @fiskp
      inc AL
		mov DS:[SI],AL
     @fiskp:
      inc DI
      inc SI
      loop @Fadeinc1
      pop DS
   End;
End;

Procedure PixRotatePalette(Pal:PixPaletteP;From,Too:Byte);
Var
	S,O:Word;
   R,G,B,Fr,Fg,Fb:Byte;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixRotatePalette.');
			Halt(0);
		End;
	{$ENDIF}
	Fr:=Pal^[From].R;
	Fg:=Pal^[From].G;
	Fb:=Pal^[From].B;
	S:=Seg(Pal^);
	O:=Ofs(Pal^)+(From*3);
	Asm
		push DS
		mov DS,S
		mov SI,O
		mov ES,S
		mov DI,O
		add SI,3
		xor CH,CH
		mov CL,Too
		sub CL,From
	  @rotlp:
		lodsb
		mov R,AL
		lodsb
		mov G,AL
		lodsb
		mov B,AL
		mov AL,R
		stosb
		mov AL,G
		stosb
		mov AL,B
		stosb
		loop @rotlp
		pop DS
	End;
	Pal^[Too].R:=Fr;
	Pal^[Too].G:=Fg;
	Pal^[Too].B:=Fb;
End;

Procedure PixRotatePaletteRev(Pal:PixPaletteP;From,Too:Byte);
Var
	S,O:Word;
	R,G,B,Fr,Fg,Fb:Byte;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixRotatePaletteRev.');
			Halt(0);
		End;
	{$ENDIF}
	Fr:=Pal^[Too].R;
	Fg:=Pal^[Too].G;
	Fb:=Pal^[Too].B;
	S:=Seg(Pal^);
	O:=Ofs(Pal^)+768-((256-Too)*3)+2;
	Asm
		std
		push DS
		mov DS,S
		mov SI,O
		mov ES,S
		mov DI,O
		sub SI,3
		xor CH,CH
		mov CL,Too
		sub CL,From
	  @rotvlp:
		lodsb
		mov B,AL
		lodsb
		mov G,AL
		lodsb
		mov R,AL
		mov AL,B
		stosb
		mov AL,G
		stosb
		mov AL,R
		stosb
		loop @rotvlp
		pop DS
		cld
	End;
	Pal^[From].R:=Fr;
	Pal^[From].G:=Fg;
	Pal^[From].B:=Fb;
End;

Function PixSavePalette(FName:String;Pal:PixPaletteP):Boolean;
Var
	F:File;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixSavePalette.');
			Halt(0);
		End;
	{$ENDIF}
	If Pos('.',FName)=0 Then
		FName:=FName+'.PAL';
	Assign(F,FName);
	Rewrite(F,1);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to create file ',FName);
		Halt(0);
	End;
	BlockWrite(F,Pal^,768);
	Close(F);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to write in ',FName);
		Halt(0);
	End;
	PixSavePalette:=IOResult=0;
End;

Function PixLoadPalette(FName:String;Pal:PixPaletteP):Boolean;
Var
	F:File;
Begin
	{$IFDEF PIXDEBUG}
		If Pal=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixLoadPalette.');
			Halt(0);
		End;
	{$ENDIF}
	If Pos('.',FName)=0 Then
		FName:=FName+'.PAL';
	Assign(F,FName);
	Reset(F,1);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('File ',FName,' not found.');
		Halt(0);
	End;
	BlockRead(F,Pal^,768);
	Close(F);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to read ',FName);
		Halt(0);
	End;
	PixLoadPalette:=IOResult=0;
End;

Function PixGetImage(Var P:Pointer;X1,Y1,X2,Y2:Integer;Alloc:Boolean):Boolean;
Var
	SkpBef,SkpAft,Wd,Hg,SkpSrc:Integer;
	S,O,VY1,VY2,VHg,VX1,VWd:Word;
Begin
	If X1>X2 Then
	Asm
		mov AX,X1
		mov BX,X2
		mov X1,BX
		mov X2,AX
	End;
	If Y1>Y2 Then
	Asm
		mov AX,Y1
		mov BX,Y2
		mov Y1,BX
		mov Y2,AX
	End;
	Wd:=X2-X1+1;
	Hg:=Y2-Y1+1;
	If Alloc Then
	Begin
		If ((Wd*Hg)+4)>MaxAvail Then
		Begin
			PixGetImage:=False;
			Exit;
		End;
		GetMem(P,Wd*Hg+4);
	End;
	If P=Nil Then
	Begin
		PixGetImage:=False;
		Exit;
	End;
	S:=Seg(P^);
	O:=Ofs(P^);
	Asm
		mov ES,S
		mov DI,O
		mov AX,Wd
		stosw
		mov AX,Hg
		stosw
		mov AX,Wd
		mul Hg
		mov CX,AX
		mov AL,00h
		rep stosb
	End;
	PixGetImage:=True;
	If X1>ClipX2 Then	Exit;
	If X2<ClipX1 Then Exit;
	If Y1>ClipY2 Then Exit;
	If Y2<ClipY1 Then Exit;
	SkpBef:=0;
	SkpAft:=0;
	VY1:=Y1;
	VY2:=Y2;
	If X1<ClipX1 Then
		SkpBef:=ClipX1-X1;
	If X2>ClipX2 Then
		SkpAft:=X2-ClipX2;
	If Y1<ClipY1 Then
		VY1:=ClipY1;
	If Y2>ClipY2 Then
		VY2:=ClipY2;
	VHg:=VY2-VY1+1;
	VX1:=X1+SkpBef;
	VWd:=Wd-SkpBef-SkpAft;
	SkpSrc:=320-VWd;
	Asm
		push DS
		lds SI,[PgLong]
		mov AX,VY1
		mov BX,AX
		shl AX,8
		shl BX,6
		add SI,AX
		add SI,BX
		add SI,VX1
		mov ES,S
		mov DI,O
		add DI,4
		mov AX,VY1
		sub AX,Y1
		mul Wd
		add DI,AX
		mov DX,VHg
		mov CX,DX
	  @gimagelp:
		add DI,SkpBef
		push CX
		mov CX,VWd
		rep movsb
		add DI,SkpAft
		add SI,SkpSrc
		pop CX
		loop @gimagelp
		pop DS
	End;
End;

Procedure PixPutImageNoTrans(Var P:Pointer;X1,Y1:Integer);
Var
	SkpBef,SkpAft,Wd,Hg,SkpSrc,X2,Y2:Integer;
	S,O,VY1,VY2,VHg,VX1,VWd:Word;
Begin
	S:=Seg(P^);
	O:=Ofs(P^);
	Asm
		push DS
		mov DS,S
		mov SI,O
		lodsw
		mov Wd,AX
		lodsw
		mov Hg,AX
		pop DS
	End;
	X2:=X1+Wd-1;
	Y2:=Y1+Hg-1;
	If X1>ClipX2 Then	Exit;
	If X2<ClipX1 Then Exit;
	If Y1>ClipY2 Then Exit;
	If Y2<ClipY1 Then Exit;
	SkpBef:=0;
	SkpAft:=0;
	VY1:=Y1;
	VY2:=Y2;
	If X1<ClipX1 Then
		SkpBef:=ClipX1-X1;
	If X2>ClipX2 Then
		SkpAft:=X2-ClipX2;
	If Y1<ClipY1 Then
		VY1:=ClipY1;
	If Y2>ClipY2 Then
		VY2:=ClipY2;
	VHg:=VY2-VY1+1;
	VX1:=X1+SkpBef;
	VWd:=Wd-SkpBef-SkpAft;
	SkpSrc:=320-VWd;
	Asm
		push DS
		les DI,[PgLong]
		mov AX,VY1
		mov BX,AX
		shl AX,8
		shl BX,6
		add DI,AX
		add DI,BX
		add DI,VX1
		mov DS,S
		mov SI,O
		add SI,4
		mov AX,VY1
		sub AX,Y1
		mul Wd
		add SI,AX
		mov DX,VHg
		mov CX,DX
	  @pimagentlp:
		add SI,SkpBef
		push CX
		mov CX,VWd
		rep movsb
		add SI,SkpAft
		add DI,SkpSrc
		pop CX
		loop @pimagentlp
		pop DS
	End;
End;

Procedure PixPutImage(P:Pointer;X1,Y1:Integer;Trans:Boolean);
Var
	SkpBef,SkpAft,Wd,Hg,SkpSrc,X2,Y2:Integer;
	S,O,VY1,VY2,VHg,VX1,VWd:Word;
Begin
	{$IFDEF PIXDEBUG}
		If P=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixPutImage.');
			Halt(0);
		End;
	{$ENDIF}
	If Not Trans Then
	Begin
		PixPutImageNoTrans(P,X1,Y1);
		Exit;
	End;
	S:=Seg(P^);
	O:=Ofs(P^);
	Asm
		push DS
		mov DS,S
		mov SI,O
		lodsw
		mov Wd,AX
		lodsw
		mov Hg,AX
		pop DS
	End;
	X2:=X1+Wd-1;
	Y2:=Y1+Hg-1;
	If X1>ClipX2 Then	Exit;
	If X2<ClipX1 Then Exit;
	If Y1>ClipY2 Then Exit;
	If Y2<ClipY1 Then Exit;
	SkpBef:=0;
	SkpAft:=0;
	VY1:=Y1;
	VY2:=Y2;
	If X1<ClipX1 Then
		SkpBef:=ClipX1-X1;
	If X2>ClipX2 Then
		SkpAft:=X2-ClipX2;
	If Y1<ClipY1 Then
		VY1:=ClipY1;
	If Y2>ClipY2 Then
		VY2:=ClipY2;
	VHg:=VY2-VY1+1;
	VX1:=X1+SkpBef;
	VWd:=Wd-SkpBef-SkpAft;
	SkpSrc:=320-VWd;
	Asm
		push DS
		les DI,[PgLong]
		mov AX,VY1
		mov BX,AX
		shl AX,8
		shl BX,6
		add DI,AX
		add DI,BX
		add DI,VX1
		mov DS,S
		mov SI,O
		add SI,4
		mov AX,VY1
		sub AX,Y1
		mul Wd
		add SI,AX
		mov DX,VHg
		mov CX,DX
	  @pimagelp:
		add SI,SkpBef
		push CX
		mov CX,VWd
	  @pimagelp2:
		mov AL,DS:[SI]
		and AL,AL
		jz @pimageskipblack
		mov ES:[DI],AL
	  @pimageskipblack:
		inc SI
		inc DI
		loop @pimagelp2
		add SI,SkpAft
		add DI,SkpSrc
		pop CX
		loop @pimagelp
		pop DS
	End;
End;

Procedure PixSaveImage(P:Pointer;FName:String;WPal:PixPalType;Pal:PixPaletteP);
Var
	F:File;
	Wd,Hg:Integer;
	S,O:Word;
	Hdr:Record
			Id:Array[1..10] Of Char;
			Version:Byte;
			Wd,Hg:Integer;
		End;
	Pl:PixPalette;
Begin
	{$IFDEF PIXDEBUG}
		If P=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixSaveImage.');
			Halt(0);
		End;
	{$ENDIF}
	If Pos('.',FName)=0 Then
		FName:=FName+'.P2I';
	Assign(F,FName);
	Rewrite(F,1);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to create ',FName);
		Halt(0);
	End;
	S:=Seg(P^);
	O:=Ofs(P^);
	Asm
		push DS
		mov DS,S
		mov SI,O
		lodsw
		mov Wd,AX
		lodsw
		mov Hg,AX
		pop DS
	End;
	Hdr.Id:='PIX2IMAGE'#26;
	Hdr.Version:=1;
	Hdr.Wd:=Wd;
	Hdr.Hg:=Hg;
	BlockWrite(F,Hdr,SizeOf(Hdr));
	BlockWrite(F,P^,Wd*Hg+4);
	Case WPal Of
		PIXPALVAR: BlockWrite(F,PixPal,768);
		CURRENT,NOWHERE:Begin
			PixGetPalette(@Pl);
			BlockWrite(F,Pl,768);
		End;
		SPECIFIEDVAR: BlockWrite(F,Pal^,768);
	End;
	Close(F);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to write in ',FName);
		Halt(0);
	End;
End;

Procedure PixLoadImage(Var P:Pointer;FName:String;WPal:PixPalType;Pal:PixPaletteP);
Var
	F:File;
	Hdr:Record
			Id:Array[1..10] Of Char;
			Version:Byte;
			Wd,Hg:Integer;
		End;
	Pl:PixPalette;
Begin
	P:=Nil;
	If Pos('.',FName)=0 Then
		FName:=FName+'.P2I';
	Assign(F,FName);
	Reset(F,1);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('File ',FName,' not found.');
		Halt(0);
	End;
	BlockRead(F,Hdr,SizeOf(Hdr));
	If (Hdr.Id<>'PIX2IMAGE'#26) Or (Hdr.Version<>1) Or (IOResult>0) Then
	Begin
		Close(F);
		Exit;
	End;
	If MaxAvail<Hdr.Wd*Hdr.Hg+4 Then
	Begin
		Close(F);
		Exit;
	End;
	GetMem(P,Hdr.Wd*Hdr.Hg+4);
	If P=Nil Then
	Begin
		Close(F);
		Exit;
	End;
	BlockRead(F,P^,Hdr.Wd*Hdr.Hg+4);
	Case WPal Of
		PIXPALVAR: BlockRead(F,PixPal,768);
		CURRENT:Begin
			BlockRead(F,Pl,768);
			PixSetPalette(@Pl);
		End;
		SPECIFIEDVAR: BlockRead(F,Pal^,768);
	End;
	Close(F);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to read in ',FName);
		Halt(0);
	End;
End;

Procedure PixLoadPri(Var P:Pointer;FName:String);
Var
	F:File;
	Wd,Hg:Integer;
Begin
	If Pos('.',FName)=0 Then
		FName:=FName+'.PRI';
	Assign(F,FName);
	Reset(F,1);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('File ',FName,' not found.');
		Halt(0);
	End;
	BlockRead(F,Wd,2);
	BlockRead(F,Hg,2);
	If Wd*Hg+4>MaxAvail Then
	Begin
		Close(F);
		Exit;
	End;
	GetMem(P,Wd*Hg+4);
	Seek(F,0);
	BlockRead(F,P^,Wd*Hg+4);
	Close(F);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to read in ',FName);
		Halt(0);
	End;
End;

Procedure PixDeAllocImage(Var P:Pointer);
Var
	Wd,Hg:Integer;
	S,O:Word;
Begin
	{$IFDEF PIXDEBUG}
		If P=Nil Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid pointer in function PixDeAllocImage.');
			Halt(0);
		End;
	{$ENDIF}
	S:=Seg(P^);
	O:=Ofs(P^);
	Asm
		push DS
		mov DS,S
		mov SI,O
		lodsw
		mov Wd,AX
		lodsw
		mov Hg,AX
		pop DS
	End;
	FreeMem(P,Wd*Hg+4);
End;

Constructor PixSprite.Init;
Var
	C:Integer;
Begin
	CurSet:=1;
	For C:=1 To 20 Do
	Begin
		NbFrm[C]:=0;
		CurFrm[C]:=1;
	End;
	Way:=1;
End;

Procedure PixSprite.AddFrame(NSet:Byte;NImg:Pointer);
Begin
	Inc(NbFrm[NSet]);
	Img[NSet,NbFrm[NSet]]:=NImg;
End;

Procedure PixSprite.NewSet(NSet:Byte);
Begin
	CurSet:=NSet;
End;

Procedure PixSprite.Draw;
Begin
	PixPutImage(Img[CurSet,CurFrm[CurSet]],X,Y,True);
End;

Function PixSprite.Step:Boolean;
Begin
	Step:=False;
	Inc(CurFrm[CurSet]);
	If CurFrm[CurSet]>NbFrm[CurSet] Then
	Begin
		CurFrm[CurSet]:=1;
		Step:=True;
	End;
End;

Function PixSprite.StepRev:Boolean;
Begin
	StepRev:=False;
	Dec(CurFrm[CurSet]);
	If CurFrm[CurSet]=0 Then
	Begin
		CurFrm[CurSet]:=NbFrm[CurSet];
		StepRev:=True;
	End;
End;

Function PixSprite.PingPong:Boolean;
Begin
	PingPong:=False;
	If Way=1 Then
	Begin
		Inc(CurFrm[CurSet]);
		If CurFrm[CurSet]=NbFrm[CurSet] Then
			Way:=2;
	End
	Else
	Begin
		Dec(CurFrm[CurSet]);
		If CurFrm[CurSet]=1 Then
		Begin
			Way:=1;
			PingPong:=True;
		End;
	End;
End;

Destructor PixSprite.Done;
Begin
End;

Function PixIntToStr(Num:LongInt):String;
Var
	S:String;
Begin
	Str(Num,S);
	PixIntToStr:=S;
End;

Function PixStrToInt(S:String):LongInt;
Var
	N:LongInt;
	E:Integer;
Begin
	Val(S,N,E);
	PixStrToInt:=N;
End;

Begin
	NPg:=0;
End.
